local lcCurrDelete, ;
	lcCurrOrder, ;
	llDone, ;
	lcBlank, ;
	laFields[1], ;
	lnFields, ;
	lnI, ;
	lcField, ;
	lcDefault

* Save the current DELETED setting and order and
* set them as we require.

lcCurrDelete = set('DELETED')
lcCurrOrder  = order()
set deleted off
set order to DELETED descending

* Go to the top of the file, which should be the
* first deleted record if there are any. Then
* process records until we get what we want.

locate
llDone = .F.
do while not llDone
	do case

* If this record is deleted and we can lock it, set
* each field to its default value, blank any fields
* we don't have a default for, and recall the
* record.

		case deleted() and rlock()
			lcBlank  = ''
			lnFields = afields(laFields)
			for lnI = 1 to lnFields
				lcField   = laFields(lnI, 1)
				lcDefault = laFields(lnI, 9)
				if empty(lcDefault)
					lcBlank = iif(empty(lcBlank), 'fields ', ;
						lcBlank + ',') + lcField
				else
					replace (lcField) with evaluate(lcDefault)
				endif empty(lcDefault)
			next lnI
			blank &lcBlank next 1
			recall
			llDone = .T.

* If this record is deleted but we can't locked it,
* try the next one.

		case deleted()
			skip

* If this record isn't deleted, there aren't any
* more, so just add a new one.

		otherwise
			append blank
			llDone = rlock()
	endcase
enddo while not llDone

* Clean up things we changed.

if lcCurrDelete = 'ON'
	set deleted on
endif lcCurrDelete = 'ON'
set order to (lcCurrOrder)
return
